# EchoProperties

Extends \Task

Displays all the current properties in the build. The output can be sent to a file if desired.

Attribute "destfile" defines a file to send the properties to. This can be processed as a standard property file later.

Attribute "prefix" defines a prefix which is used to filter the properties only those properties starting with this prefix will be echoed.

By default, the "failonerror" attribute is enabled. If an error occurs while writing the properties to a file, and this attribute is enabled, then a BuildException will be thrown. If disabled, then IO errors will be reported as a log statement, but no error will be thrown.

Examples:

    <echoproperties  />

Report the current properties to the log.

     <echoproperties destfile="my.properties" />

Report the current properties to the file "my.properties", and will fail the build if the file could not be created or written to.

     <echoproperties destfile="my.properties" failonerror="false"
         prefix="phing" />

Report all properties beginning with 'phing' to the file "my.properties", and will log a message if the file could not be created or written to, but will still allow the build to continue.

author | Siad Ardroumli siad.ardroumli@gmail.com
package | phing.tasks.system

### Methods

## failOnErrorAction

    failOnErrorAction(\Exception $exception = null, string $message = '', integer $level = \Project::MSG_INFO)

throws |

### Arguments

#### $exception

`\Exception`

#### $message

`string`

#### $level

`integer`

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## Send the key/value pairs in the hashtable to the given output stream.

    saveProperties(array $allProps, \OutputStream $os)

Only those properties matching the `prefix` constraint will be sent to the output stream. The output stream will be closed when this method returns.

throws | on output errors on other errors

### Arguments

#### $allProps

`array`

propfile to save

#### $os

`\OutputStream`

output stream

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## Set a file to store the property output. If this is never specified, then the output will be sent to the Phing log.

    setDestfile(string|\PhingFile $destfile)

### Arguments

#### $destfile

`string|\PhingFile`

file to store the property output

## If true, the task will fail if an error occurs writing the properties file, otherwise errors are just logged.

    setFailOnError( $failonerror)

### Arguments

#### $failonerror

``

## Set the output format - xml or text.

    setFormat(string $ea)

### Arguments

#### $ea

`string`

an enumerated `FormatAttribute` value

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## If the prefix is set, then only properties which start with this prefix string will be recorded. If regex is not set and if this is never set, or it is set to an empty string or <tt>null</tt>, then all properties will be recorded. <P>

    setPrefix(string $prefix)

For example, if the attribute is set as:

    <echoproperties  prefix="phing." />

then the property "phing.home" will be recorded, but "phing-example" will not.

### Arguments

#### $prefix

`string`

The new prefix value

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## If the regex is set, then only properties whose names match it will be recorded. If prefix is not set and if this is never set, or it is set to an empty string or <tt>null</tt>, then all properties will be recorded.<P>

    setRegex(string $regex)

For example, if the attribute is set as:

    <echoproperties  prefix=".*phing.*" />

then the properties "phing.home" and "user.phing" will be recorded, but "phing-example" will not.

### Arguments

#### $regex

`string`

The new regex value

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the input file.

    setSrcfile(string|\PhingFile $file)

### Arguments

#### $file

`string|\PhingFile`

the input file

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## textSaveProperties

    textSaveProperties(\Properties $props, \OutputStream $os, string $header)

throws | on an I/O error during a write.

### Arguments

#### $props

`\Properties`

the properties to record

#### $os

`\OutputStream`

record the properties to this output stream

#### $header

`string`

prepend this header to the property output

## Output the properties as xml output.

    xmlSaveProperties(\Properties $props, \OutputStream $os)

throws |

### Arguments

#### $props

`\Properties`

the properties to save

#### $os

`\OutputStream`

the output stream to write to (Note this gets closed)

### Properties

## the properties element.

    PROPERTIES :

static

### Type(s)

``

## the property element.

    PROPERTY :

static

### Type(s)

``

## name attribute for property, testcase and testsuite elements.

    ATTR_NAME :

static

### Type(s)

``

## value attribute for property elements.

    ATTR_VALUE :

static

### Type(s)

``

## the input file.

    inFile : \PhingFile

var |

### Type(s)

`\PhingFile`

## File object pointing to the output file. If this is null, then we output to the project log, not to a file.

    destfile : \PhingFile

var |

### Type(s)

`\PhingFile`

## If this is true, then errors generated during file output will become build errors, and if false, then such errors will be logged, but not thrown.

    failonerror : boolean

var |

### Type(s)

`boolean`

## format

    format : string

var |

### Type(s)

`string`

## prefix

    prefix : string

var |

### Type(s)

`string`

## regex

    regex : string

var |

### Type(s)

`string`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`